<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>VSLActivator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/marte/vsl/ui/internal/VSLActivator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2006, 2016 CEA LIST and others.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *     </em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *     </em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_comment"> * generated by Xtext</em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.marte.vsl.ui.internal;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.Collections;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.apache.log4j.Logger;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.plugin.AbstractUIPlugin;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.ui.shared.SharedStateModule;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.util.Modules2;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.osgi.framework.BundleContext;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> com.google.common.collect.Maps;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> com.google.inject.Guice;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> com.google.inject.Injector;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> com.google.inject.Module;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * This class was generated. Customizations should only happen in a newly</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> * introduced subclass.</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/marte/vsl/ui/internal/VSLActivator.html">VSLActivator</a> <strong class="jxr_keyword">extends</strong> AbstractUIPlugin {
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String ORG_ECLIPSE_PAPYRUS_MARTE_VSL_VSL = <span class="jxr_string">"org.eclipse.papyrus.marte.vsl.VSL"</span>;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> Logger logger = Logger.getLogger(VSLActivator.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/marte/vsl/ui/internal/VSLActivator.html">VSLActivator</a> INSTANCE;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<strong class="jxr_keyword">private</strong> Map&lt;String, Injector&gt; injectors = Collections.synchronizedMap(Maps.&lt;String, Injector&gt; newHashMapWithExpectedSize(1));
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	@Override
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> start(BundleContext context) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  		<strong class="jxr_keyword">super</strong>.start(context);
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  		INSTANCE = <strong class="jxr_keyword">this</strong>;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	}
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	@Override
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> stop(BundleContext context) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		injectors.clear();
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		INSTANCE = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">super</strong>.stop(context);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/marte/vsl/ui/internal/VSLActivator.html">VSLActivator</a> getInstance() {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">return</strong> INSTANCE;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	}
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">public</strong> Injector getInjector(String language) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		<strong class="jxr_keyword">synchronized</strong> (injectors) {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			Injector injector = injectors.get(language);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			<strong class="jxr_keyword">if</strong> (injector == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  				injectors.put(language, injector = createInjector(language));
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			}
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  			<strong class="jxr_keyword">return</strong> injector;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		}
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	}
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">protected</strong> Injector createInjector(String language) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			Module runtimeModule = getRuntimeModule(language);
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			Module sharedStateModule = getSharedStateModule();
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			Module uiModule = getUiModule(language);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  			Module mergedModule = Modules2.mixin(runtimeModule, sharedStateModule, uiModule);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			<strong class="jxr_keyword">return</strong> Guice.createInjector(mergedModule);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		} <strong class="jxr_keyword">catch</strong> (Exception e) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			logger.error(<span class="jxr_string">"Failed to create injector for "</span> + language);
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			logger.error(e.getMessage(), e);
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(<span class="jxr_string">"Failed to create injector for "</span> + language, e);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	}
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  	<strong class="jxr_keyword">protected</strong> Module getRuntimeModule(String grammar) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<strong class="jxr_keyword">if</strong> (ORG_ECLIPSE_PAPYRUS_MARTE_VSL_VSL.equals(grammar)) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> org.eclipse.papyrus.marte.vsl.VSLRuntimeModule();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(grammar);
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	<strong class="jxr_keyword">protected</strong> Module getUiModule(String grammar) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		<strong class="jxr_keyword">if</strong> (ORG_ECLIPSE_PAPYRUS_MARTE_VSL_VSL.equals(grammar)) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> org.eclipse.papyrus.marte.vsl.ui.VSLUiModule(<strong class="jxr_keyword">this</strong>);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(grammar);
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	<strong class="jxr_keyword">protected</strong> Module getSharedStateModule() {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> SharedStateModule();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 	}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
